const db = new Dexie('smac_db');
/*const db_sch = {};
db_sch.device =  '++id,' +SMAC_ID_DEVICE;
db_sch.property = '++id,' + SMAC_ID_DEVICE +',' + SMAC_ID_PROPERTY +',['+SMAC_ID_DEVICE+'+'+SMAC_ID_PROPERTY+']';
db_sch.config = '++id';
console.log(db_sch);*/
db.version(1).stores({
    device: '++id, SMAC_ID_DEVICE',
    property:'++id, SMAC_ID_DEVICE, SMAC_ID_PROPERTY, [SMAC_ID_DEVICE+SMAC_ID_PROPERTY]',
    config: '++id, key'
});
console.log(db);

//async function startDB() {


async function dbSetConfig(key, value) {
    var d = {};
    d["key"] = key;
    d["value"] = value;
    await db.config.put(d);
}

async function dbGetConfig(key) {
    var d = {};
    d["key"] = key;
    return await db.config.get(d);
}

async function dbRemoveConfig(key) {
    var d = {};
    d["key"] = key;
    await db.config.where(d).delete();
}

/*async function dbAddDevice(dat) {
    await db.device.put(dat);
}

async function dbGetDevice(dat) {
    return await db.device.where(dat).toArray();
}

async function dbGetDeviceAll() {
    return await db.device.where({}).toArray();
}

async function dbRemoveDevice(dat) {
    await db.device.where(dat).delete();
}

async function dbAddProperty(dat) {
    await db.property.put(dat);
}

async function dbGetProperty(dat) {
    return await db.property.where(dat).toArray();
}

async function dbRemoveProperty(dat) {
    await db.property.where(dat).delete();
}*/


/*for(var j=0; j<2; j++) {
    var d = {};
    d[ "SMAC_ID_DEVICE" ] = "D"+j;
    d[ "SMAC_NAME_DEVICE" ] = "smac_Dtest";
    await db.device.add(d);
    for(var i=0; i< 4; i++) {
        var p = {};
        p[ "SMAC_ID_DEVICE" ] = "D"+j;
        p[ "SMAC_ID_PROPERTY"] = "P"+i;
        p[ "SMAC_NAME_PROPERTY"] = "SWITCH"+i;
        p[ "SMAC_VALUE" ] = "0";
        p[ "SMAC_VALUE_MIN"] = "0";
        p[ "SMAC_VALUE_MAX" ] = "1";
        //console.log(p);
        await db.property.add(p);
    }
}

// reading devs
const devs = await db.device
    .toArray();
console.log(devs);
var a = {};
a[ "SMAC_ID_DEVICE"] = "D0";
a[ "SMAC_ID_PROPERTY" ] = "P1";
console.log(a);
const props = await db.property
    .where(a)
    .toArray();
console.log(props);
var prop1 = await db.property
    .get({SMAC_ID_DEVICE: "D1", SMAC_ID_PROPERTY: "P1"});
console.log(prop1);

await db.property.where({SMAC_ID_DEVICE: "D1", SMAC_ID_PROPERTY: "P1"}).modify({SMAC_VALUE: "1"});

//db.property.put({SMAC_ID_DEVICE: "D1", SMAC_ID_PROPERTY: "P1", SMAC_VALUE:"1"});
var prop1 = await db.property
    .where({SMAC_ID_DEVICE: "D1", SMAC_ID_PROPERTY: "P1"}).first();
console.log(prop1);

await db.property.where({SMAC_ID_DEVICE: "D1", SMAC_ID_PROPERTY: "P1"}).delete();          
var prop1 = await db.property.where({SMAC_ID_DEVICE: "D1", SMAC_ID_PROPERTY: "P1"}).toArray();
console.log(prop1);*/
